<app-loading *ngIf="isLoading"></app-loading>
<div id='request-approve'>
  <div id='request-list' class="content__item content__item--border bg__content--default app-card">
    <form nz-form [formGroup]="form" scroll-spy>
      <div nz-row [nzGutter]="[30,30]">
        <div nz-col nzXs="24" nzLg="6">
          <mb-input-text formControlName="keySearch"
            [mbType]="isSubmitted && form.controls['keySearch'].errors ? 'error' : 'default'"
            [mbShowError]="isSubmitted && form.controls['keySearch'].errors !== null"
            [mbErrors]="form.controls['keySearch'].errors"
            [mbErrorDefs]="[
              { errorName: 'required', errorDescription: 'selfService.validate.required' | translate: {'param': 'selfService.label.keySearchEmployee' | translate}}
              , { errorName: 'maxlength', errorDescription: 'selfService.validate.maxLength' | translate: {'numberLength': '2000' }}
            ]"
            mbPlaceholderText="{{'selfService.label.keySearchEmployee' | translate}}"
            mbLabelText="{{'selfService.label.keySearchEmployee' | translate}}"></mb-input-text>
        </div>
        <div nz-col nzXs="24" nzLg="6">
          <mb-date-picker mbPlaceholderText="{{'selfService.label.fromTime' | translate}}"
            mbLabelText="{{'selfService.label.fromTime' | translate}}" formControlName="fromTime">
          </mb-date-picker>
        </div>
        <div nz-col nzXs="24" nzLg="6">
          <mb-date-picker mbPlaceholderText="{{'selfService.label.toTime' | translate}}"
            mbLabelText="{{'selfService.label.toTime' | translate}}" formControlName="toTime"
            [mbType]="isSubmitted && (form.controls['toTime'].errors || form.errors) ? 'error' : 'default'"
            [mbShowError]="isSubmitted && (form.controls['toTime'].errors || form.errors) != null"
            [mbErrors]="form.controls['toTime'].errors ? form.controls['toTime'].errors : ( form.errors ? form.errors : null)"
            [mbErrorDefs]="[
                  { errorName: 'rangeDateError', errorDescription: 'selfService.validate.rangeDate.pareDateMore' | translate: {toDate: 'selfService.label.toTime' | translate, fromDate: 'selfService.label.fromTime' | translate}}
              ]"></mb-date-picker>
        </div>

        <div nz-col nzXs="24" nzLg="6">
          <mb-select-check-able
            [mbShowAction]="false"
            [mbDataSelects]="REQUEST_APPROVE_STATUS_DATASOURCE"
            formControlName="listStatus"
            mbPlaceholder="{{'selfService.label.status' | translate }}"
            mbLabelText="{{'selfService.label.status' | translate}}">
          </mb-select-check-able>
        </div>
        

        <div nz-col nzXs='24' nzLg='24' class="text-center">
          <mb-button (click)='doSearch(1)' mbButtonSize='MEDIUM' mbButtonAvailableStyle='SEARCH'
                     mbButtonText="{{'selfService.label.search' | translate}}"></mb-button>
        </div>

      </div>
    </form>
  </div>
  <div class='search__content--group content__item content__item--border app-list'>
    <mb-table-wrap>
      <div class="headerTableSelect">
        <mb-button *ngIf="listRequestId.length > 0" (nzOnConfirm)='approveByList()' nz-popconfirm
          nzPopconfirmTitle="{{'selfService.table.action.confirmApprove' | translate}}"
          nzCancelText="{{'selfService.table.action.cancel2' | translate}}" nzOkType="primary"
          nzOkText="{{'selfService.table.action.yes' | translate}}" mbButtonSize='SMALL'
          mbButtonAvailableStyle='PRIMARY' mbButtonText="{{'selfService.table.action.approve' | translate}}"></mb-button>
        <mb-button *ngIf="listRequestId.length > 0" (click)="openRejectByList()" mbButtonSize='SMALL'
          mbButtonAvailableStyle='DANGER' mbButtonText="{{'selfService.table.action.reject' | translate}}"></mb-button>
      </div>
      <div>
        <p *ngIf="listRequestId.length > 0" style="margin: 0">{{'selfService.label.selected' | translate}}:
          {{listRequestId.length}}</p>
      </div>
      <mb-table (changePageNum)='doSearch($event)' [tableConfig]='tableConfig' [tableData]='searchResult'></mb-table>
    </mb-table-wrap>
  </div>

  <ng-template #statusTmpl let-status='status'>
    <nz-tag [nzColor]="TAG.STATUS_DRAFT" *ngIf='status === REQUEST_STATUS.DRAFT || !status'>{{ getStatus(status ?? 0)}}
    </nz-tag>
    <nz-tag [nzColor]="TAG.STATUS_WAIT_APPROVE" *ngIf='status === REQUEST_STATUS.WAIT_APPROVE'>{{ getStatus(status) }}</nz-tag>
    <nz-tag [nzColor]="TAG.STATUS_APPROVED" *ngIf='status === REQUEST_STATUS.APPROVED'>{{ getStatus(status) }}</nz-tag>
    <nz-tag [nzColor]="TAG.STATUS_REJECT" *ngIf='status === REQUEST_STATUS.REJECT'>{{ getStatus(status) }}</nz-tag>
    <nz-tag [nzColor]="TAG.STATUS_REQUEST_CANCEL" *ngIf='status === REQUEST_STATUS.REQUEST_CANCEL'>{{ getStatus(status) }}</nz-tag>
    <nz-tag [nzColor]="TAG.STATUS_CANCEL" *ngIf='status === REQUEST_STATUS.CANCEL'>{{ getStatus(status) }}</nz-tag>
    <nz-tag [nzColor]="TAG.STATUS_AJUST" *ngIf='status === REQUEST_STATUS.AJUST'>{{ getStatus(status) }}</nz-tag>
    <nz-tag [nzColor]="TAG.STATUS_WAIT_APPROVE" *ngIf='status === REQUEST_STATUS.BACK_DATE'>{{ getStatus(status) }}</nz-tag>
    <nz-tag [nzColor]="TAG.STATUS_WAIT_APPROVE" *ngIf='status === REQUEST_STATUS.CANCEL_BACKDATE'>{{ getStatus(status) }}</nz-tag>
  </ng-template>

  <ng-template #reasonTmpl let-reasonCode='reasonCode'>
    {{ getReasonLabel(reasonCode) }}
  </ng-template>
  <!-- Thời gian nghỉ -->
  <ng-template #timeLeaveTmpl let-listAbsRequestLeavesText='listAbsRequestLeavesText'>
    <ng-container *ngIf="listAbsRequestLeavesText">
      <ul class="leave-time">
        <li *ngFor="let item of listAbsRequestLeavesText">{{item}}</li>
      </ul>
    </ng-container>
  </ng-template>
  <!-- Người xét duyệt -->
  <ng-template #reviewersTmpl let-listReviewer='listReviewer'>
    <ng-container *ngIf="listReviewer">
      <div *ngFor="let item of listReviewer">
        <ng-container [ngTemplateOutlet]="statusTemplate" [ngTemplateOutletContext]="item"></ng-container>
        {{item.fullName}}
      </div>
    </ng-container>
  </ng-template>
  <!-- Người phê duyệt -->
  <ng-template #approversTmpl let-listApprover='listApprover'>
    <ng-container *ngIf="listApprover">
      <div *ngFor="let item of listApprover">
        <ng-container [ngTemplateOutlet]="statusTemplate" [ngTemplateOutletContext]="item"></ng-container>
        {{item.fullName}}
      </div>
    </ng-container>
  </ng-template>

  <!-- template action -->
  <ng-template #actionTmpl let-status='status' let-requestId='requestId' let-allowApprove='allowApprove'
    let-viewButtonAction="viewButtonAction">
    <em nz-icon
       class="menu__item--btn"
       nz-button
       nzType="more"
       nzTheme="outline"
       nzTrigger="click"
       nz-dropdown
       [nzDropdownMenu]="menu"
       [nzClickHide]="false"
    ></em>
    <nz-dropdown-menu #menu="nzDropdownMenu">
      <ul nz-menu>
        <!-- Phê duyệt -->
        <li *ngIf="viewButtonAction" (nzOnConfirm)="actionApprove(requestId)" nz-button
            nz-menu-item nz-popconfirm nzPopconfirmTitle="{{'selfService.table.action.confirmApprove' | translate}}"
            nzCancelText="{{'selfService.table.action.cancel2' | translate}}" nzOkType="primary"
            nzOkText="{{'selfService.table.action.yes' | translate}}">
          {{ (allowApprove ? 'selfService.table.action.approve' : 'selfService.table.action.review') |
          translate}}
        </li>
        <!-- Từ chối phê duyệt -->
        <li *ngIf="viewButtonAction" (click)="actionReject(requestId, allowApprove, footerRejectTmpl)" [nzDanger]="true"
          nz-menu-item nz-button>
          {{ (allowApprove ? 'selfService.table.action.reject' : 'selfService.table.action.unreview') |
          translate}}
        </li>
        <!-- Xem chi tiết -->
        <li nz-menu-item nz-button (click)="actionViewDetail(requestId)">
          {{'selfService.table.action.viewDetail' | translate}}
        </li>
      </ul>
    </nz-dropdown-menu>
  </ng-template>


  <ng-template #footerRejectTmpl>
    <mb-button mbButtonType="NO_BORDER" mbButtonSize="LARGE" (click)="modal.destroy()" mbButtonBgColor="transparent"
      mbButtonText="{{'common.button.cancel' | translate}}"></mb-button>
    <mb-button mbButtonType="NO_BORDER" mbButtonSize="LARGE" (click)="modal.getContentComponent().save()"
      mbButtonAvailableStyle="PRIMARY" mbButtonText="{{'common.button.save' | translate}}"></mb-button>
  </ng-template>

  <ng-template #selectTmpl let-requestId='requestId' let-viewButtonAction='viewButtonAction'>
    <input type="checkbox" [value]="requestId" [checked]="listRequestId.indexOf(requestId) > -1"
      (change)="onCheckChange($event)" [disabled]="!viewButtonAction">
  </ng-template>
</div>
<ng-template #statusTemplate let-status="status">
  <span *ngIf="status === 1" class="far fa-clock ic-wait-approve" nz-tooltip [nzTooltipTitle]="'selfService.table.statusType.waitApprove' | translate"></span>
  <span *ngIf="status === 2" class="far fa-check ic-approved" nz-tooltip [nzTooltipTitle]="'selfService.table.statusType.approved' | translate"></span>
  <span *ngIf="status === 3" class="far fa-times ic-reject" nz-tooltip [nzTooltipTitle]="'selfService.table.statusType.reject' | translate"></span>
</ng-template>